# Logical relations for system F with recursive types, references, concurrency and continuations (F-mu-ref-conc-cc) together with a proof of correctness of compilation of cooperative concurrency using continuations

## Prerequisites
The following prerequisites are required for compiling the development. We have included the specific versions mentioned below within the tar archive of the artifact in the folder "prerequisites".

- Coq 8.9
- Autosubst: Note that the official release of Autosubst does not compile with Coq 8.9. However, there is a version of this library in the branch ```coq89-devel``` in the clone of autosubst repository at https://github.com/amintimany/autosubst/tree/coq89-devel that does compile with Coq 8.9. It can be compiled using the command ```make``` and installed using the command ```make install```.
- iris: 0655aa19d67a1f8a364625bd8ecf5bb1ae0c2c75 (https://gitlab.mpi-sws.org/iris/iris). It can be compiled using the command ```make``` and installed using the command ```make install```.
- stdpp: 87b2fe62995413c6dea48c97c1ae4e8976f10d01 (https://gitlab.mpi-sws.org/iris/stdpp). It can be compiled using the command ```make``` and installed using the command ```make install```.

Notice that iris depends on stdpp so the latter must be installed before the former can be compiled!

## Compiling (type checking) the development:
Simply use the ```make``` command.

This command, if necessary, uses coq_makefile to create a makefile
called Makefile.coq and run make on it.

We recommend using -j option of make to take advantage of multiple
processor cores as the compilation takes a relatively long time ~30
minutes with -j4 on author's machine.

Use the command ```make html``` to regenerate the prettified html version of the source (see blow).

## Browsable HTML version of the Coq source code
A prettified version of the Coq codes of the development can be found in the "html" folder. These files are generated by the Coqdoc tool and the presentation is enhanced by the CoqdocJS tool (https://github.com/tebbi/coqdocjs). The file "index.html" acts as an overview of this development and has links to files in the "html" folder. The "html" folder and its contents can be recreated using the command ```make html```.

## De Bruijn indices and Autosubst:
We use the Autosubst library for representing de Bruijn indices. For more information about the Autosubst library, e.g., its syntax for substitutions, please see the file "autosubst/manual.pdf". This manual is also available above as "Autosubst Manual".

## Remark about (possible) super-user rights being required:
If compiling from source and installing, you can choose to install Coq globally or locally at configure time. In case it is being installed globally one would need to have super user rights to install Coq. Any subsequent installations of libraries (e.g., autosubst, stdpp, and iris, in our case) would also need to be installed globally if Coq is. In that case, super user rights are also necessary to install those libraries.
